'use strict';
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function (sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};
        if (i % 2) {
            ownKeys(Object(source), true).forEach(function (key) {
                _defineProperty(target, key, source[key]);
            });
        }
        else if (Object.getOwnPropertyDescriptors) {
            Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        }
        else {
            ownKeys(Object(source)).forEach(function (key) {
                Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
            });
        }
    }
    return target;
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    }
    else {
        obj[key] = value;
    }
    return obj;
}
/*
CSV Stringify

Please look at the [project documentation](https://csv.js.org/stringify/) for
additional information.
*/
var Transform = require('stream').Transform;
var bom_utf8 = Buffer.from([239, 187, 191]);
var Stringifier = /** @class */ (function (_super) {
    __extends(Stringifier, _super);
    function Stringifier(opts) {
        if (opts === void 0) { opts = {}; }
        var _this = _super.call(this, _objectSpread(_objectSpread({}, {
            writableObjectMode: true,
        }), opts)) || this;
        var options = {};
        var err; // Merge with user options
        for (var opt in opts) {
            options[underscore(opt)] = opts[opt];
        }
        if (err = _this.normalize(options)) {
            throw err;
        }
        switch (options.record_delimiter) {
            case 'auto':
                options.record_delimiter = null;
                break;
            case 'unix':
                options.record_delimiter = '\n';
                break;
            case 'mac':
                options.record_delimiter = '\r';
                break;
            case 'windows':
                options.record_delimiter = '\r\n';
                break;
            case 'ascii':
                options.record_delimiter = '\u001e';
                break;
            case 'unicode':
                options.record_delimiter = '\u2028';
                break;
        } // Expose options
        _this.options = options; // Internal state
        _this.state = {
            stop: false,
        }; // Information
        _this.info = {
            records: 0,
        };
        return _this;
    }
    Stringifier.prototype.normalize = function (options) {
        // Normalize option `bom`
        if (options.bom === undefined || options.bom === null || options.bom === false) {
            options.bom = false;
        }
        else if (options.bom !== true) {
            return new CsvError('CSV_OPTION_BOOLEAN_INVALID_TYPE', ['option `bom` is optional and must be a boolean value,', "got " + JSON.stringify(options.bom)]);
        } // Normalize option `delimiter`
        if (options.delimiter === undefined || options.delimiter === null) {
            options.delimiter = ',';
        }
        else if (Buffer.isBuffer(options.delimiter)) {
            options.delimiter = options.delimiter.toString();
        }
        else if (typeof options.delimiter !== 'string') {
            return new CsvError('CSV_OPTION_DELIMITER_INVALID_TYPE', ['option `delimiter` must be a buffer or a string,', "got " + JSON.stringify(options.delimiter)]);
        } // Normalize option `quote`
        if (options.quote === undefined || options.quote === null) {
            options.quote = '"';
        }
        else if (options.quote === true) {
            options.quote = '"';
        }
        else if (options.quote === false) {
            options.quote = '';
        }
        else if (Buffer.isBuffer(options.quote)) {
            options.quote = options.quote.toString();
        }
        else if (typeof options.quote !== 'string') {
            return new CsvError('CSV_OPTION_QUOTE_INVALID_TYPE', ['option `quote` must be a boolean, a buffer or a string,', "got " + JSON.stringify(options.quote)]);
        } // Normalize option `quoted`
        if (options.quoted === undefined || options.quoted === null) {
            options.quoted = false;
        }
        else { // todo
        } // Normalize option `quoted_empty`
        if (options.quoted_empty === undefined || options.quoted_empty === null) {
            options.quoted_empty = undefined;
        }
        else { // todo
        } // Normalize option `quoted_match`
        if (options.quoted_match === undefined || options.quoted_match === null || options.quoted_match === false) {
            options.quoted_match = null;
        }
        else if (!Array.isArray(options.quoted_match)) {
            options.quoted_match = [options.quoted_match];
        }
        if (options.quoted_match) {
            for (var _i = 0, _a = options.quoted_match; _i < _a.length; _i++) {
                var quoted_match = _a[_i];
                var isString = typeof quoted_match === 'string';
                var isRegExp = quoted_match instanceof RegExp;
                if (!isString && !isRegExp) {
                    return Error("Invalid Option: quoted_match must be a string or a regex, got " + JSON.stringify(quoted_match));
                }
            }
        } // Normalize option `quoted_string`
        if (options.quoted_string === undefined || options.quoted_string === null) {
            options.quoted_string = false;
        }
        else { // todo
        } // Normalize option `eof`
        if (options.eof === undefined || options.eof === null) {
            options.eof = true;
        }
        else { // todo
        } // Normalize option `escape`
        if (options.escape === undefined || options.escape === null) {
            options.escape = '"';
        }
        else if (Buffer.isBuffer(options.escape)) {
            options.escape = options.escape.toString();
        }
        else if (typeof options.escape !== 'string') {
            return Error("Invalid Option: escape must be a buffer or a string, got " + JSON.stringify(options.escape));
        }
        if (options.escape.length > 1) {
            return Error("Invalid Option: escape must be one character, got " + options.escape.length + " characters");
        } // Normalize option `header`
        if (options.header === undefined || options.header === null) {
            options.header = false;
        }
        else { // todo
        } // Normalize option `columns`
        options.columns = this.normalize_columns(options.columns); // Normalize option `quoted`
        if (options.quoted === undefined || options.quoted === null) {
            options.quoted = false;
        }
        else { // todo
        } // Normalize option `cast`
        if (options.cast === undefined || options.cast === null) {
            options.cast = {};
        }
        else { // todo
        } // Normalize option cast.bigint
        if (options.cast.bigint === undefined || options.cast.bigint === null) {
            // Cast boolean to string by default
            options.cast.bigint = function (value) { return '' + value; };
        } // Normalize option cast.boolean
        if (options.cast.boolean === undefined || options.cast.boolean === null) {
            // Cast boolean to string by default
            options.cast.boolean = function (value) { return value ? '1' : ''; };
        } // Normalize option cast.date
        if (options.cast.date === undefined || options.cast.date === null) {
            // Cast date to timestamp string by default
            options.cast.date = function (value) { return '' + value.getTime(); };
        } // Normalize option cast.number
        if (options.cast.number === undefined || options.cast.number === null) {
            // Cast number to string using native casting by default
            options.cast.number = function (value) { return '' + value; };
        } // Normalize option cast.object
        if (options.cast.object === undefined || options.cast.object === null) {
            // Stringify object as JSON by default
            options.cast.object = function (value) { return JSON.stringify(value); };
        } // Normalize option cast.string
        if (options.cast.string === undefined || options.cast.string === null) {
            // Leave string untouched
            options.cast.string = function (value) {
                return value;
            };
        } // Normalize option `record_delimiter`
        if (options.record_delimiter === undefined || options.record_delimiter === null) {
            options.record_delimiter = '\n';
        }
        else if (Buffer.isBuffer(options.record_delimiter)) {
            options.record_delimiter = options.record_delimiter.toString();
        }
        else if (typeof options.record_delimiter !== 'string') {
            return Error("Invalid Option: record_delimiter must be a buffer or a string, got " + JSON.stringify(options.record_delimiter));
        }
    };
    Stringifier.prototype._transform = function (chunk, encoding, callback) {
        if (this.state.stop === true) {
            return;
        } // Chunk validation
        if (!Array.isArray(chunk) && typeof chunk !== 'object') {
            this.state.stop = true;
            return callback(Error("Invalid Record: expect an array or an object, got " + JSON.stringify(chunk)));
        } // Detect columns from the first record
        if (this.info.records === 0) {
            if (Array.isArray(chunk)) {
                if (this.options.header === true && !this.options.columns) {
                    this.state.stop = true;
                    return callback(Error('Undiscoverable Columns: header option requires column option or object records'));
                }
            }
            else if (this.options.columns === undefined || this.options.columns === null) {
                this.options.columns = this.normalize_columns(Object.keys(chunk));
            }
        } // Emit the header
        if (this.info.records === 0) {
            this.bom();
            this.headers();
        } // Emit and stringify the record if an object or an array
        try {
            this.emit('record', chunk, this.info.records);
        }
        catch (err) {
            this.state.stop = true;
            return this.emit('error', err);
        } // Convert the record into a string
        var chunk_string;
        if (this.options.eof) {
            chunk_string = this.stringify(chunk);
            if (chunk_string === undefined) {
                return;
            }
            else {
                chunk_string += this.options.record_delimiter;
            }
        }
        else {
            chunk_string = this.stringify(chunk);
            if (chunk_string === undefined) {
                return;
            }
            else {
                if (this.options.header || this.info.records) {
                    chunk_string = this.options.record_delimiter + chunk_string;
                }
            }
        } // Emit the csv
        this.info.records++;
        this.push(chunk_string);
        callback();
    };
    Stringifier.prototype._flush = function (callback) {
        if (this.info.records === 0) {
            this.bom();
            this.headers();
        }
        callback();
    };
    Stringifier.prototype.stringify = function (chunk, chunkIsHeader) {
        if (chunkIsHeader === void 0) { chunkIsHeader = false; }
        if (typeof chunk !== 'object') {
            return chunk;
        }
        var _a = this.options, columns = _a.columns, header = _a.header;
        var record = []; // Record is an array
        if (Array.isArray(chunk)) {
            // We are getting an array but the user has specified output columns. In
            // this case, we respect the columns indexes
            if (columns) {
                chunk.splice(columns.length);
            } // Cast record elements
            for (var i = 0; i < chunk.length; i++) {
                var field = chunk[i];
                var _b = this.__cast(field, {
                    index: i,
                    column: i,
                    records: this.info.records,
                    header: chunkIsHeader,
                }), err = _b[0], value = _b[1];
                if (err) {
                    this.emit('error', err);
                    return;
                }
                record[i] = [value, field];
            } // Record is a literal object
        }
        else {
            if (columns) {
                for (var i = 0; i < columns.length; i++) {
                    var field = get(chunk, columns[i].key);
                    var _c = this.__cast(field, {
                        index: i,
                        column: columns[i].key,
                        records: this.info.records,
                        header: chunkIsHeader,
                    }), err = _c[0], value = _c[1];
                    if (err) {
                        this.emit('error', err);
                        return;
                    }
                    record[i] = [value, field];
                }
            }
            else {
                for (var _i = 0, chunk_1 = chunk; _i < chunk_1.length; _i++) {
                    var column = chunk_1[_i];
                    var field = chunk[column];
                    var _d = this.__cast(field, {
                        index: i,
                        column: columns[i].key,
                        records: this.info.records,
                        header: chunkIsHeader,
                    }), err = _d[0], value = _d[1];
                    if (err) {
                        this.emit('error', err);
                        return;
                    }
                    record.push([value, field]);
                }
            }
        }
        var csvrecord = '';
        var _loop_1 = function (i) {
            var options = void 0, err = void 0;
            var _e = record[i], value = _e[0], field = _e[1];
            if (typeof value === 'string') {
                options = this_1.options;
            }
            else if (isObject(value)) {
                // let { value, ...options } = value
                options = value;
                value = options.value;
                delete options.value;
                if (typeof value !== 'string' && value !== undefined && value !== null) {
                    this_1.emit('error', Error("Invalid Casting Value: returned value must return a string, null or undefined, got " + JSON.stringify(value)));
                    return { value: void 0 };
                }
                options = _objectSpread(_objectSpread({}, this_1.options), options);
                if (err = this_1.normalize(options)) {
                    this_1.emit('error', err);
                    return { value: void 0 };
                }
            }
            else if (value === undefined || value === null) {
                options = this_1.options;
            }
            else {
                this_1.emit('error', Error("Invalid Casting Value: returned value must return a string, an object, null or undefined, got " + JSON.stringify(value)));
                return { value: void 0 };
            }
            var delimiter = options.delimiter, escape_1 = options.escape, quote = options.quote, quoted = options.quoted, quoted_empty = options.quoted_empty, quoted_string = options.quoted_string, quoted_match = options.quoted_match, record_delimiter = options.record_delimiter;
            if (value) {
                if (typeof value !== 'string') {
                    this_1.emit('error', Error("Formatter must return a string, null or undefined, got " + JSON.stringify(value)));
                    return { value: null };
                }
                var containsdelimiter = delimiter.length && value.indexOf(delimiter) >= 0;
                var containsQuote = quote !== '' && value.indexOf(quote) >= 0;
                var containsEscape = value.indexOf(escape_1) >= 0 && escape_1 !== quote;
                var containsRecordDelimiter = value.indexOf(record_delimiter) >= 0;
                var quotedString = quoted_string && typeof field === 'string';
                var quotedMatch = quoted_match && quoted_match.filter(function (quoted_match) {
                    if (typeof quoted_match === 'string') {
                        return value.indexOf(quoted_match) !== -1;
                    }
                    else {
                        return quoted_match.test(value);
                    }
                });
                quotedMatch = quotedMatch && quotedMatch.length > 0;
                var shouldQuote = containsQuote === true || containsdelimiter || containsRecordDelimiter || quoted || quotedString || quotedMatch;
                if (shouldQuote === true && containsEscape === true) {
                    var regexp = escape_1 === '\\' ? new RegExp(escape_1 + escape_1, 'g') : new RegExp(escape_1, 'g');
                    value = value.replace(regexp, escape_1 + escape_1);
                }
                if (containsQuote === true) {
                    var regexp = new RegExp(quote, 'g');
                    value = value.replace(regexp, escape_1 + quote);
                }
                if (shouldQuote === true) {
                    value = quote + value + quote;
                }
                csvrecord += value;
            }
            else if (quoted_empty === true || field === '' && quoted_string === true && quoted_empty !== false) {
                csvrecord += quote + quote;
            }
            if (i !== record.length - 1) {
                csvrecord += delimiter;
            }
        };
        var this_1 = this;
        for (var i = 0; i < record.length; i++) {
            var state_1 = _loop_1(i);
            if (typeof state_1 === "object")
                return state_1.value;
        }
        return csvrecord;
    };
    Stringifier.prototype.bom = function () {
        if (this.options.bom !== true) {
            return;
        }
        this.push(bom_utf8);
    };
    Stringifier.prototype.headers = function () {
        if (this.options.header === false) {
            return;
        }
        if (this.options.columns === undefined) {
            return;
        }
        var headers = this.options.columns.map(function (column) { return column.header; });
        if (this.options.eof) {
            headers = this.stringify(headers, true) + this.options.record_delimiter;
        }
        else {
            headers = this.stringify(headers);
        }
        this.push(headers);
    };
    Stringifier.prototype.__cast = function (value, context) {
        var type = typeof value;
        try {
            if (type === 'string') {
                // Fine for 99% of the cases
                return [undefined, this.options.cast.string(value, context)];
            }
            else if (type === 'bigint') {
                return [undefined, this.options.cast.bigint(value, context)];
            }
            else if (type === 'number') {
                return [undefined, this.options.cast.number(value, context)];
            }
            else if (type === 'boolean') {
                return [undefined, this.options.cast.boolean(value, context)];
            }
            else if (value instanceof Date) {
                return [undefined, this.options.cast.date(value, context)];
            }
            else if (type === 'object' && value !== null) {
                return [undefined, this.options.cast.object(value, context)];
            }
            else {
                return [undefined, value, value];
            }
        }
        catch (err) {
            return [err];
        }
    };
    Stringifier.prototype.normalize_columns = function (columns) {
        if (columns === undefined || columns === null) {
            return undefined;
        }
        if (typeof columns !== 'object') {
            throw Error('Invalid option "columns": expect an array or an object');
        }
        if (!Array.isArray(columns)) {
            var newcolumns = [];
            for (var k in columns) {
                newcolumns.push({
                    key: k,
                    header: columns[k],
                });
            }
            columns = newcolumns;
        }
        else {
            var newcolumns = [];
            for (var _i = 0, columns_1 = columns; _i < columns_1.length; _i++) {
                var column = columns_1[_i];
                if (typeof column === 'string') {
                    newcolumns.push({
                        key: column,
                        header: column,
                    });
                }
                else if (typeof column === 'object' && column !== undefined && !Array.isArray(column)) {
                    if (!column.key) {
                        throw Error('Invalid column definition: property "key" is required');
                    }
                    if (column.header === undefined) {
                        column.header = column.key;
                    }
                    newcolumns.push(column);
                }
                else {
                    throw Error('Invalid column definition: expect a string or an object');
                }
            }
            columns = newcolumns;
        }
        return columns;
    };
    return Stringifier;
}(Transform));
var stringify = function () {
    var data, options, callback;
    for (var i in arguments) {
        var argument = arguments[i];
        var type = typeof argument;
        if (data === undefined && Array.isArray(argument)) {
            data = argument;
        }
        else if (options === undefined && isObject(argument)) {
            options = argument;
        }
        else if (callback === undefined && type === 'function') {
            callback = argument;
        }
        else {
            throw new CsvError('CSV_INVALID_ARGUMENT', ['Invalid argument:', "got " + JSON.stringify(argument) + " at index " + i]);
        }
    }
    var stringifier = new Stringifier(options);
    if (callback) {
        var chunks_1 = [];
        stringifier.on('readable', function () {
            var chunk;
            while ((chunk = this.read()) !== null) {
                chunks_1.push(chunk);
            }
        });
        stringifier.on('error', function (err) {
            callback(err);
        });
        stringifier.on('end', function () {
            callback(undefined, chunks_1.join(''));
        });
    }
    if (data !== undefined) {
        // Give a chance for events to be registered later
        if (typeof setImmediate === 'function') {
            setImmediate(function () {
                for (var _i = 0, data_2 = data; _i < data_2.length; _i++) {
                    var record = data_2[_i];
                    stringifier.write(record);
                }
                stringifier.end();
            });
        }
        else {
            for (var _i = 0, data_1 = data; _i < data_1.length; _i++) {
                var record = data_1[_i];
                stringifier.write(record);
            }
            stringifier.end();
        }
    }
    return stringifier;
};
var CsvError = /** @class */ (function (_super) {
    __extends(CsvError, _super);
    function CsvError(code, message) {
        var contexts = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            contexts[_i - 2] = arguments[_i];
        }
        var _this = this;
        if (Array.isArray(message)) {
            message = message.join(' ');
        }
        _this = _super.call(this, message) || this;
        if (Error.captureStackTrace !== undefined) {
            Error.captureStackTrace(_this, CsvError);
        }
        _this.code = code;
        for (var _a = 0, contexts_1 = contexts; _a < contexts_1.length; _a++) {
            var context = contexts_1[_a];
            for (var key in context) {
                var value = context[key];
                _this[key] = Buffer.isBuffer(value) ? value.toString() : value == null ? value : JSON.parse(JSON.stringify(value));
            }
        }
        return _this;
    }
    return CsvError;
}(Error));
stringify.Stringifier = Stringifier;
stringify.CsvError = CsvError;
module.exports = stringify;
var isObject = function (obj) {
    return typeof obj === 'object' && obj !== null && !Array.isArray(obj);
};
var underscore = function (str) {
    return str.replace(/([A-Z])/g, function (_, match) {
        return '_' + match.toLowerCase();
    });
}; // Lodash implementation of `get`
var charCodeOfDot = '.'.charCodeAt(0);
var reEscapeChar = /\\(\\)?/g;
var rePropName = RegExp(// Match anything that isn't a dot or bracket.
'[^.[\\]]+' + '|' + // Or match property names within brackets.
    '\\[(?:' + // Match a non-string expression.
    '([^"\'][^[]*)' + '|' + // Or match strings (supports escaping characters).
    '(["\'])((?:(?!\\2)[^\\\\]|\\\\.)*?)\\2' + ')\\]' + '|' + // Or match "" as the space between consecutive dots or empty brackets.
    '(?=(?:\\.|\\[\\])(?:\\.|\\[\\]|$))', 'g');
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/;
var reIsPlainProp = /^\w*$/;
var getTag = function (value) {
    if (!value) {
        value === undefined ? '[object Undefined]' : '[object Null]';
    }
    return Object.prototype.toString.call(value);
};
var isKey = function (value, object) {
    if (Array.isArray(value)) {
        return false;
    }
    var type = typeof value;
    if (type === 'number' || type === 'symbol' || type === 'boolean' || !value || isSymbol(value)) {
        return true;
    }
    return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && value in Object(object);
};
var isSymbol = function (value) {
    var type = typeof value;
    return type === 'symbol' || type === 'object' && value && getTag(value) === '[object Symbol]';
};
var stringToPath = function (string) {
    var result = [];
    if (string.charCodeAt(0) === charCodeOfDot) {
        result.push('');
    }
    string.replace(rePropName, function (match, expression, quote, subString) {
        var key = match;
        if (quote) {
            key = subString.replace(reEscapeChar, '$1');
        }
        else if (expression) {
            key = expression.trim();
        }
        result.push(key);
    });
    return result;
};
var castPath = function (value, object) {
    if (Array.isArray(value)) {
        return value;
    }
    else {
        return isKey(value, object) ? [value] : stringToPath(value);
    }
};
var toKey = function (value) {
    if (typeof value === 'string' || isSymbol(value)) {
        return value;
    }
    var result = "" + value;
    return result == '0' && 1 / value == -INFINITY ? '-0' : result;
};
var get = function (object, path) {
    path = castPath(path, object);
    var index = 0;
    var length = path.length;
    while (object != null && index < length) {
        object = object[toKey(path[index++])];
    }
    return index && index === length ? object : undefined;
};
//# sourceMappingURL=index.js.map