"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var misc = __importStar(require("../Misc"));
var HASH_MAPPING = [
    ['test', '098f6bcd4621d373cade4e832627b4f6'],
    ['key_1337', '6f42bb78b04fca15a31d4c2381ee9448'],
    ['Sed dolor ante, vehicula nec.', 'a732a497074ff27e12cfe193bc360d34'],
    ['Neque porro quisquam est qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit...', 'b9522cae373f305effab33e7e7b72a97'],
];
var NOT_AN_OBJECT = [
    0,
    1,
    false,
    true,
    'string',
    new String('string'),
    [1, 2, 'string'],
    new Date(),
];
var OBJECTS = [
    {},
    {
        name: 'Test',
        value: 'test',
    },
    Object.assign({}, {}),
];
test('Should throw an error', function () {
    expect(function () { return misc.md5(1); }).toThrow('The parameter must be a string');
});
test('Should return a valid MD5 hash', function () {
    expect.assertions(HASH_MAPPING.length);
    for (var _i = 0, HASH_MAPPING_1 = HASH_MAPPING; _i < HASH_MAPPING_1.length; _i++) {
        var mapping = HASH_MAPPING_1[_i];
        var str = mapping[0], hash = mapping[1];
        expect(misc.md5(str)).toBe(hash);
    }
});
test('Should no be an object', function () {
    expect.assertions(NOT_AN_OBJECT.length);
    for (var _i = 0, NOT_AN_OBJECT_1 = NOT_AN_OBJECT; _i < NOT_AN_OBJECT_1.length; _i++) {
        var notObject = NOT_AN_OBJECT_1[_i];
        expect(misc.isObject(notObject)).toBe(false);
    }
});
test('Should be an object', function () {
    expect.assertions(OBJECTS.length);
    for (var _i = 0, OBJECTS_1 = OBJECTS; _i < OBJECTS_1.length; _i++) {
        var obj = OBJECTS_1[_i];
        expect(misc.isObject(obj)).toBe(true);
    }
});
//# sourceMappingURL=Misc.test.js.map